package com.ann.demo.controller;

import com.alibaba.excel.ExcelReader;
import com.alibaba.excel.metadata.Sheet;
import com.alibaba.excel.support.ExcelTypeEnum;
import com.ann.demo.entity.filing.EMRDictionary;
import com.ann.demo.entity.interfaceEntity.Result;
import com.ann.demo.normalEntity.Department;
import com.ann.demo.normalEntity.PowerDept;
import com.ann.demo.normalEntity.UserModel;
import com.ann.demo.service.EMRDictionaryService;
import com.ann.demo.service.MessageService;
import com.ann.demo.service.PowerDeptService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.util.List;


@Controller
public class ImportUserController {

    static final Logger logger = LoggerFactory.getLogger(ImportUserController.class);

    @Autowired
    private PowerDeptService powerDeptService;

    @RequestMapping("/")
    public String toImportUser() {
        return "importUser";
    }

    @ResponseBody
    @RequestMapping("/getPowerDept")
    public List<PowerDept> getPowerDept() {
        return powerDeptService.getPowerDept();
    }


    @RequestMapping(value = "/uploadFile")
    @ResponseBody
    public Result uploadFile(MultipartFile file){
        //此处千万不要用InputStream，InputStream会导致无法解析出文件类型
        BufferedInputStream buffer = null;
        ExcelListener listener = null;
        try{
            buffer = new BufferedInputStream(file.getInputStream());
            listener = new ExcelListener();
            ExcelReader excelReader = new ExcelReader(buffer, ExcelTypeEnum.XLS,listener);
            excelReader.read(new Sheet(1,0, UserModel.class));
            List<Object> list = listener.getDatas();
            //excel中第一行为栏目，必然是存在一行的
            if(CollectionUtils.isEmpty(list) || list.size() < 2){
                return new Result("导入数据为空！");
            }
            //进行业务处理，list为excel中解析出的数据

            for (Object obj: list) {
                UserModel userModel = (UserModel) obj;

//                if(Object.){
//
//                }

            }



            return new Result("导入成功！");
        } catch(Exception e){
            logger.error("批量导入用户失败：",e);
        } finally {
            if(buffer != null){
                try{
                    buffer.close();
                    listener.doAfterAll();
                } catch (IOException e){
                    logger.error("导入失败",e);
                }
            }
        }
        return new Result("导入失败！");
    }

}
