package com.ann.demo.service.impl;

import com.ann.demo.entity.filing.EMRDictionary;
import com.ann.demo.normalEntity.PowerDept;
import com.ann.demo.normalEntity.User;
import com.ann.demo.primaryRepository.PowerDeptRepository;
import com.ann.demo.primaryRepository.UserRepository;
import com.ann.demo.service.UserService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * @Description
 * @Date 2019/7/9 16:43
 * @Created by  ljx
 */
@Service
public class UserServiceImpl implements UserService {

    static final Logger logger = LoggerFactory.getLogger(UserServiceImpl.class);

    // distId
    public static Integer doctor;
    @Value("${role.doctor}")
    public void setDoctor(Integer doctor) {
        UserServiceImpl.doctor = doctor;
    }
    public static Integer getDoctor() {
        return doctor;
    }

    public static Integer nurse;
    @Value("${role.nurse}")
    public void setNurse(Integer nurse) {
        UserServiceImpl.nurse = nurse;
    }
    public static Integer getNurse() {
        return nurse;
    }


    @Autowired
    UserRepository userRepository;

    @Autowired
    EMRDictionaryServiceImpl emrDictionaryService;

    @Autowired
    PowerDeptRepository powerDeptRepository;


    @Override
    public void save(User user) throws Exception{
        // 获取科室  根据科室类型区分临床和非临床，临床的然后有资质的就是医生，没有资质的就是护士
        //先判断用户是否存在，如果存在那么就更新
        User user1 = userRepository.findByUSER_IDAndIsValid(user.getUSER_ID(), 1);
        if(user1 != null){
            user.setId(user1.getId());
            user.setUpdater("ann");
            user.setUSER_PWD(user1.getUSER_PWD());
            user.setUpdateDate(new Date().toLocaleString());
            user.setCreater(user1.getCreater());
            user.setCREATE_DATE(user1.getCREATE_DATE());
        }

        Integer roleId = 0;
        if (user.getUSER_DEPT() != null) {
            EMRDictionary emrDictionary = emrDictionaryService.findEMRDictionary(user.getUSER_DEPT());
            if (emrDictionary != null) {
                Integer  CLINIC_ATTR = emrDictionary.getCLINIC_ATTR();
                if ( CLINIC_ATTR == null) {
                    CLINIC_ATTR = 0;
                }
                if (CLINIC_ATTR == 0) {
                    if (user.getEDUCATION_FLAG() == 0) { // 无资质 护士
                        roleId = nurse;
                    } else { // 有资质 为 1 医生
                        roleId = doctor;
                    }
                }
            }
            PowerDept powerDept = powerDeptRepository.findByDeptCodeAndEffective(user.getUSER_DEPT() ,1);
            user.setUSER_DEPT(powerDept == null ? user.getUSER_DEPT() : powerDept.getDeptId()  +"");
        }
        user.setUSER_PWD("RERERERE");
        user.setUSER_TYPE(roleId);
        userRepository.save(user);
    }

    @Override
    public void delete(User user) throws Exception {
        User user1 = userRepository.findByUSER_IDAndIsValid(user.getUSER_ID(), 1);
        userRepository.updateUser(user1.getId());
    }
}
